Snow_OTBarPreview = {}

Snow_OTBarPreview.UserData =
{
bShowMark = true,
bTransparent = false,
}

RegisterCustomData("Snow_OTBarPreview.UserData")

function Snow_OTBarPreview.OnFrameCreate()

	if Snow_OTBarPreview.UserData.bShowMark then
		this:Lookup("CheckBox_bShowMark"):Check(true)
		this:Lookup("",""):Lookup("Handle_Preview"):Lookup("Handle_Marks"):Show()
	else
		this:Lookup("CheckBox_bShowMark"):Check(false)
		this:Lookup("",""):Lookup("Handle_Preview"):Lookup("Handle_Marks"):Hide()
	end

end

function Snow_OTBarPreview.OnCheckBoxCheck()

	local szName = this:GetName()

	if szName == "CheckBox_bShowMark" then
		Snow_OTBarPreview.UserData.bShowMark = true
		this:GetParent():Lookup("",""):Lookup("Handle_Preview"):Lookup("Handle_Marks"):Show()
	elseif szName == "CheckBox_bTransparent" then
		Snow_OTBarPreview.UserData.bTransparent = true
		this:GetParent():Lookup("",""):Lookup("Handle_Preview"):Lookup("Shadow_FrameBG"):Hide()
		this:GetParent():Lookup("",""):Lookup("Image_BG"):SetAlpha(0)
	end

end

function Snow_OTBarPreview.OnCheckBoxUncheck()

	local szName = this:GetName()

	if szName == "CheckBox_bShowMark" then
		Snow_OTBarPreview.UserData.bShowMark = false
		this:GetParent():Lookup("",""):Lookup("Handle_Preview"):Lookup("Handle_Marks"):Hide()
	elseif szName == "CheckBox_bTransparent" then
		Snow_OTBarPreview.UserData.bTransparent = false
		this:GetParent():Lookup("",""):Lookup("Handle_Preview"):Lookup("Shadow_FrameBG"):Show()
		this:GetParent():Lookup("",""):Lookup("Image_BG"):SetAlpha(255)
	end

end
