Snow_OTBarSetting =
{
bError = false,
bAnimatedPreview = false,
nAnimateChange = 0,
nStepper = 0,
nIconW = 0,
nIconH = 0,
nAnimateMin = 0.7,
nAnimateMax = 1.5,
nAnimateW = 0,
nAnimateH = 0,
}

Snow_OTBarSetting.UserData =
{
szCurrentSkin = "Skin_Org",
}


Snow_OTBarSetting.SkinScheme = {}
Snow_OTBarSetting.CurrentSetting = {}

RegisterCustomData("Snow_OTBarSetting.UserData")


function Snow_OTBarSetting.OnFrameCreate()

	this:SetPoint("CENTER", 0, 0, "CENTER", 100, 0)

	local x,y = this:GetAbsPos()
	Station.Lookup("Normal/Snow_OTBarPreview"):SetAbsPos(x - 412,y + 4)

	Snow_OTBarSetting.UpdateSetting(Snow_OTBarSetting.SkinScheme[Snow_OTBarSetting.UserData.szCurrentSkin])

	if Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 0 then
		this:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
	elseif Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 1 then
		this:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
	elseif Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 2 then
		this:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
	elseif Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 3 then
		this:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
	end

	if Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 0 then
		this:Lookup("Btn_nAnimateMove"):Lookup("",""):Lookup(0):SetText("")
	elseif Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 1 then
		this:Lookup("Btn_nAnimateMove"):Lookup("",""):Lookup(0):SetText("")
	elseif Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 2 then
		this:Lookup("Btn_nAnimateMove"):Lookup("",""):Lookup(0):SetText("")
	end
	this:Lookup("Btn_ApplySetting"):Enable(false)

	local handle = this:Lookup("",""):Lookup("Handle_List")
	handle:Clear()
	local nNum = 0
	for i = 1,  #Snow_OTBarSkinList do
		local hI = handle:AppendItemFromIni("interface\\Snow_OTBar\\Snow_OTBarSetting.ini","Handle_Item","Handle_Item_"..Snow_OTBarSkinList[i])
		hI:SetRelPos(0,nNum * 30)
		hI:Lookup("Text_ListSkinName"):SetText(Snow_OTBarSkinList[i])
		if  Snow_OTBarSkinList[i] == Snow_OTBarSetting.UserData.szCurrentSkin then
			hI:Lookup("Image_ItemBg"):SetFrame(1)
		else
			hI:Lookup("Image_ItemBg"):Hide()
		end
	end

	Snow_OTBarSetting.UpdateScrollInfo(handle)

end

function Snow_OTBarSetting.OnFrameRender()

	if not Snow_OTBarSetting.bAnimatedPreview then
		return
	end

	Snow_OTBarSetting.nStepper = Snow_OTBarSetting.nStepper + 0.2

	if Snow_OTBarSetting.nStepper > 100 then
		Snow_OTBarSetting.nStepper = 1
	end

	Snow_OTBarSetting.UpdateAnimatedPreview(Snow_OTBarSetting.nStepper / 100)

end

function Snow_OTBarSetting.OnLButtonClick()

	local szName = this:GetName()
	local frameself = Station.Lookup("Normal/Snow_OTBarSetting")

	if szName == "Btn_AnimatedPreview" then
		Snow_OTBarSetting.bAnimatedPreview = not Snow_OTBarSetting.bAnimatedPreview
		if Snow_OTBarSetting.bAnimatedPreview then
			this:Lookup("",""):Lookup(0):SetText("ȡԤ")
			Snow_OTBarSetting.nAnimateChange = 1
		else
			this:Lookup("",""):Lookup(0):SetText("̬Ԥ")
			Snow_OTBarSetting.nStepper = 0
			Snow_OTBarSetting.nAnimateChange = 0
			Snow_OTBarSetting.UpdateAnimatedPreview(1,true)
		end
	elseif szName == "Btn_ApplySetting" then
		for k,v in pairs(Snow_OTBarSetting.SkinScheme) do
			if k == Snow_OTBarSetting.CurrentSetting.SkinName then
				Snow_OTBarSetting.SkinScheme[k] = Snow_OTBarSetting.CurrentSetting
				this:Enable(false)
				Snow_OTBarSetting.OutputSetting(false,false)
				Snow_OTBar.ChangeSkin()
				break
			end
		end
	elseif szName == "Btn_Default" then
		local msg =
		{
			szName = "Snow_OTBarSetting.ConfirmApplyDefault",
			szMessage = "ȷԭʼ趨ֵ",
			{szOption = g_tStrings.STR_HOTKEY_SURE, fnAction =
			function()
				Snow_OTBarSetting.InputSetting(false,true)
				Snow_OTBarSetting.UpdateSetting(Snow_OTBarSetting.SkinScheme[Snow_OTBarSetting.UserData.szCurrentSkin])
				frameself:Lookup("Btn_ApplySetting"):Enable(true)
			end},
			{szOption = g_tStrings.STR_HOTKEY_CANCEL}
		}
		MessageBox(msg)
	elseif szName == "Btn_SetDefault" then
		if frameself:Lookup("Btn_ApplySetting"):IsEnabled() then
			local msg =
			{
				szName = "Snow_OTBarSetting.SetDefaultError",
				szMessage = "ʧܣδӦõǰ趨",
				{szOption = g_tStrings.STR_HOTKEY_SURE}
			}
			MessageBox(msg)
		else
			local msg =
			{
				szName = "Snow_OTBarSetting.ConfirmSetDefault",
				szMessage = "ȷΪʼֵ",
				{szOption = g_tStrings.STR_HOTKEY_SURE, fnAction =
				function()
					Snow_OTBarSetting.OutputSetting(false,true)
				end},
				{szOption = g_tStrings.STR_HOTKEY_CANCEL}
			}
			MessageBox(msg)
		end
	elseif szName:match("Btn_%a+_%a+_%a") then
		for item,side in szName:gmatch("Btn_(%a+_%a+)_(%a)") do
			local nLastNum = frameself:Lookup("Edit_"..item):GetText()
			if side == "L" then
				frameself:Lookup("Edit_"..item):SetText(nLastNum - 1)
			elseif side == "R" then
				frameself:Lookup("Edit_"..item):SetText(nLastNum + 1)
			end
		end
	elseif szName == "Btn_Close" then
		if frameself:Lookup("Btn_ApplySetting"):IsEnabled() then
			local msg =
			{
				szName = "Snow_OTBarSetting.NotYetApplySetting",
				szMessage = "δӦõǰ趨ȷӦ",
				{szOption = g_tStrings.STR_HOTKEY_SURE, fnAction =
				function()
					for k,v in pairs(Snow_OTBarSetting.SkinScheme) do
						if k == Snow_OTBarSetting.CurrentSetting.SkinName then
							Snow_OTBarSetting.SkinScheme[k] = Snow_OTBarSetting.CurrentSetting
							Snow_OTBarSetting.UpdateSetting(Snow_OTBarSetting.CurrentSetting)
							frameself:Lookup("Btn_ApplySetting"):Enable(false)
							Snow_OTBarSetting.bAnimatedPreview = false
							Snow_OTBarSetting.nStepper = 0
							Snow_OTBarSetting.UpdateAnimatedPreview(1,true)
							Snow_OTBar.ChangeSkin()
							Snow_OTBarSetting.OutputSetting(true,false)
							Snow_OTBarSetting.PanelSwitch()
							break
						end
					end

				end
				},
				{
				szOption = g_tStrings.STR_HOTKEY_CANCEL,fnAction =
				function()
					Snow_OTBarSetting.CurrentSetting = Snow_OTBarSetting.SkinScheme[Snow_OTBarSetting.UserData.szCurrentSkin]
					Snow_OTBarSetting.bAnimatedPreview = false
					Snow_OTBarSetting.nStepper = 0
					Snow_OTBarSetting.UpdateAnimatedPreview(1,true)
					Snow_OTBarSetting.PanelSwitch()
				end
				}
			}
			MessageBox(msg)
		else
			Snow_OTBarSetting.bAnimatedPreview = false
			Snow_OTBarSetting.nStepper = 0
			Snow_OTBarSetting.UpdateAnimatedPreview(1,true)
			Snow_OTBarSetting.PanelSwitch()
		end
	elseif szName == "Btn_nIconMove" then
		local menu =
		{
			{
				szOption = "ֹ",fnAction =
				function()
					Snow_OTBarSetting.CurrentSetting.Icon.nMoveType = 0
					frameself:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
					frameself:Lookup("Btn_ApplySetting"):Enable(true)
				end,
				bMCheck = true,
				bChecked = Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 0,
			},
			{
				szOption = "С",fnAction =
				function()
					Snow_OTBarSetting.CurrentSetting.Icon.nMoveType = 1
					frameself:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
					frameself:Lookup("Btn_ApplySetting"):Enable(true)
				end,
				bMCheck = true,
				bChecked = Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 1,
			},
			{
				szOption = "Ŵ",fnAction =
				function()
					Snow_OTBarSetting.CurrentSetting.Icon.nMoveType = 2
					frameself:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
					frameself:Lookup("Btn_ApplySetting"):Enable(true)
				end,
				bMCheck = true,
				bChecked = Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 2,
			}
		}
		if Snow_OTBarSetting.CurrentSetting.Frame.nType ~= 1 then
			table.insert(menu,
			{
				szOption = "",fnAction =
				function()
					Snow_OTBarSetting.CurrentSetting.Icon.nMoveType = 3
					frameself:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
					frameself:Lookup("Btn_ApplySetting"):Enable(true)
				end,
				bMCheck = true,
				bChecked = Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 3,
			})
		end
		PopupMenu(menu)
	elseif szName == "Btn_nAnimateMove" then
		local menu =
		{
			{
				szOption = "ֹ",fnAction =
				function()
					Snow_OTBarSetting.CurrentSetting.Animate.nMoveType = 0
					frameself:Lookup("Btn_nAnimateMove"):Lookup("",""):Lookup(0):SetText("")
					frameself:Lookup("Btn_ApplySetting"):Enable(true)
				end,
				bMCheck = true,
				bChecked = Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 0,
			},
			{
				szOption = "",fnAction =
				function()
					Snow_OTBarSetting.CurrentSetting.Animate.nMoveType = 1
					frameself:Lookup("Btn_nAnimateMove"):Lookup("",""):Lookup(0):SetText("")
					frameself:Lookup("Btn_ApplySetting"):Enable(true)
				end,
				bMCheck = true,
				bChecked = Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 1,
			},
		}
		if Snow_OTBarSetting.CurrentSetting.Frame.nMoveType ~= 1 then
			table.insert(menu,
			{
				szOption = "",fnAction =
				function()
					Snow_OTBarSetting.CurrentSetting.Animate.nMoveType = 2
					frameself:Lookup("Btn_nAnimateMove"):Lookup("",""):Lookup(0):SetText("")
					frameself:Lookup("Btn_ApplySetting"):Enable(true)
				end,
				bMCheck = true,
				bChecked = Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 2,
			})
		end
		PopupMenu(menu)
	elseif szName == "Btn_nFontName" then
		Snow_OTBarFont.szName = ""
		Snow_OTBarFont.PanelSwitch()
	elseif szName == "Btn_nFontTime" then
		Snow_OTBarFont.szName = "ʱ"
		Snow_OTBarFont.PanelSwitch()
	end

end

function Snow_OTBarSetting.OnCheckBoxCheck()

	local szName = this:GetName()
	local frameself = Station.Lookup("Normal/Snow_OTBarSetting")

	if szName:match("^CheckBox_Display_") then
		local item = szName:match("CheckBox_Display_(%a+)")
		Snow_OTBarSetting.CurrentSetting[item].bShow = true
		Snow_OTBarSetting.UpdatePreview()
		frameself:Lookup("Btn_ApplySetting"):Enable(true)
	elseif szName == "CheckBox_bLeftRight" then
		frameself:Lookup("CheckBox_bUpDown"):Check(false)
		frameself:Lookup("CheckBox_bRound"):Check(false)
		Snow_OTBarSetting.CurrentSetting.Frame.nType = 0
		Snow_OTBarSetting.UpdatePreview()
		frameself:Lookup("Btn_ApplySetting"):Enable(true)
	elseif szName == "CheckBox_bRound" then
		frameself:Lookup("CheckBox_bLeftRight"):Check(false)
		frameself:Lookup("CheckBox_bUpDown"):Check(false)
		Snow_OTBarSetting.CurrentSetting.Frame.nType = 1
		Snow_OTBarSetting.UpdatePreview()
		frameself:Lookup("Btn_ApplySetting"):Enable(true)
	elseif szName == "CheckBox_bUpDown" then
		frameself:Lookup("CheckBox_bLeftRight"):Check(false)
		frameself:Lookup("CheckBox_bRound"):Check(false)
		Snow_OTBarSetting.CurrentSetting.Frame.nType = 2
		Snow_OTBarSetting.UpdatePreview()
		frameself:Lookup("Btn_ApplySetting"):Enable(true)
	end

end

function Snow_OTBarSetting.OnCheckBoxUncheck()

	local szName = this:GetName()
	local frameself = Station.Lookup("Normal/Snow_OTBarSetting")

	if szName:match("^CheckBox_Display_") then
		local item = szName:match("CheckBox_Display_(%a+)")
		Snow_OTBarSetting.CurrentSetting[item].bShow = false
		Snow_OTBarSetting.UpdatePreview()
		frameself:Lookup("Btn_ApplySetting"):Enable(true)
	end

end

function Snow_OTBarSetting.OnEditChanged()

	local szName = this:GetName()
	local frameself = Station.Lookup("Normal/Snow_OTBarSetting")

	if szName:match("Edit_%a+_%a+") then
		for item,data in szName:gmatch("Edit_(%a+)_(%a+)") do
			data = data:gsub("Pos",""):gsub("Size","")
			data = "n"..data
			Snow_OTBarSetting.CurrentSetting[item][data] = tonumber(this:GetText())
			if Snow_OTBarSetting.CurrentSetting[item][data] == nil then
				return
			end
			Snow_OTBarSetting.UpdatePreview()
			frameself:Lookup("Btn_ApplySetting"):Enable(true)
		end
	elseif szName:match("Edit_SkinName") then
		Snow_OTBarSetting.CurrentSetting.SkinName = this:GetText()
		Snow_OTBarSetting.bError = false
		frameself:Lookup("Btn_ApplySetting"):Enable(true)
	elseif szName:match("Edit_AuthorName") then
		Snow_OTBarSetting.CurrentSetting.AuthorName = this:GetText()
		frameself:Lookup("Btn_ApplySetting"):Enable(true)
	end

end

function Snow_OTBarSetting.OnFrameKeyDown()

	local szKey = GetKeyName(Station.GetMessageKey())

	if szKey == "Esc" then
		Snow_OTBarSetting.bAnimatedPreview = false
		Snow_OTBarSetting.nStepper = 0
		Snow_OTBarSetting.UpdateAnimatedPreview(1,true)
		Snow_OTBarSetting.PanelSwitch()
		return 1
	end

end

function Snow_OTBarSetting.OnItemMouseEnter()

	local szName = this:GetName()
	if szName:match("^Handle_Item") then
		this:Lookup("Image_ItemBg"):Show()
	end

end

function Snow_OTBarSetting.OnItemMouseLeave()

	local szName = this:GetName()
	if szName:match("^Handle_Item") then
		local currentskin = szName:match("^Handle_Item_(.+)")
		if currentskin ~= Snow_OTBarSetting.UserData.szCurrentSkin then
			this:Lookup("Image_ItemBg"):Hide()
		end
	end

end

function Snow_OTBarSetting.OnItemLButtonClick()

	local szName = this:GetName()
	local frameself = Station.Lookup("Normal/Snow_OTBarSetting")
	if szName:match("^Handle_Item") then
		local currentskin = szName:match("^Handle_Item_(.+)")
		if currentskin ~= Snow_OTBarSetting.UserData.szCurrentSkin then
			if frameself:Lookup("Btn_ApplySetting"):IsEnabled() then
				local msg =
				{
					szName = "Snow_OTBarSetting.NotYetApplySetting",
					szMessage = "δӦõǰ趨ȷӦ",
					{szOption = g_tStrings.STR_HOTKEY_SURE, fnAction =
					function()
						for k,v in pairs(Snow_OTBarSetting.SkinScheme) do
							if k == Snow_OTBarSetting.CurrentSetting.SkinName then
								frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):SetFrame(0)
								frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):Hide()
								Snow_OTBarSetting.SkinScheme[k] = Snow_OTBarSetting.CurrentSetting
								Snow_OTBarSetting.CurrentSetting = Snow_OTBarSetting.SkinScheme[currentskin]
								Snow_OTBarSetting.UserData.szCurrentSkin = currentskin
								Snow_OTBar.ChangeSkin()
								Snow_OTBarSetting.UpdateSetting(Snow_OTBarSetting.CurrentSetting)
								frameself:Lookup("Btn_ApplySetting"):Enable(false)
								Snow_OTBarSetting.OutputSetting(false)
								frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..currentskin):Lookup("Image_ItemBg"):SetFrame(1)
								frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..currentskin):Lookup("Image_ItemBg"):Show()
								break
							end
						end
					end
					},
					{szOption = g_tStrings.STR_HOTKEY_CANCEL,fnAction =
					function()
						frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):SetFrame(0)
						frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):Hide()
						Snow_OTBarSetting.CurrentSetting = Snow_OTBarSetting.SkinScheme[currentskin]
						Snow_OTBarSetting.UserData.szCurrentSkin = currentskin
						Snow_OTBar.ChangeSkin()
						Snow_OTBarSetting.UpdateSetting(Snow_OTBarSetting.CurrentSetting)
						frameself:Lookup("Btn_ApplySetting"):Enable(false)
						frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..currentskin):Lookup("Image_ItemBg"):SetFrame(1)
						frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..currentskin):Lookup("Image_ItemBg"):Show()
					end}
				}
				MessageBox(msg)
			else
				frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):SetFrame(0)
				frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):Hide()
				Snow_OTBarSetting.CurrentSetting = Snow_OTBarSetting.SkinScheme[currentskin]
				Snow_OTBarSetting.UserData.szCurrentSkin = currentskin
				Snow_OTBar.ChangeSkin()
				Snow_OTBarSetting.UpdateSetting(Snow_OTBarSetting.CurrentSetting)
				frameself:Lookup("Btn_ApplySetting"):Enable(false)
				frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..currentskin):Lookup("Image_ItemBg"):SetFrame(1)
				frameself:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..currentskin):Lookup("Image_ItemBg"):Show()
			end
		end
	end

end

function Snow_OTBarSetting.UpdateScrollInfo(handle)

	handle:FormatAllItemPos()
	local frame = handle:GetRoot()
	local wA, hA = handle:GetAllItemSize()
	local w, h = handle:GetSize()
	local nStep = (hA - h) / 10
	if nStep > 0 then
		frame:Lookup("Scroll_List"):Show()
		frame:Lookup("Btn_Up"):Show()
		frame:Lookup("Btn_Down"):Show()
	else
		frame:Lookup("Scroll_List"):Hide()
		frame:Lookup("Btn_Up"):Hide()
		frame:Lookup("Btn_Down"):Hide()
	end
	frame:Lookup("Scroll_List"):Lookup("Btn_Scroll"):SetSize(15,180 - nStep)
	frame:Lookup("Scroll_List"):SetStepCount(nStep)
end

function Snow_OTBarSetting.OnScrollBarPosChanged()

	local nCurrentValue = this:GetScrollPos()
	local frame = this:GetParent()
	if nCurrentValue == 0 then
		frame:Lookup("Btn_Up"):Enable(false)
	else
		frame:Lookup("Btn_Up"):Enable(true)
	end
	if nCurrentValue == this:GetStepCount() then
		frame:Lookup("Btn_Down"):Enable(false)
	else
		frame:Lookup("Btn_Down"):Enable(true)
	end

    local handle = frame:Lookup("", "Handle_List")
    handle:SetItemStartRelPos(0, - nCurrentValue * 10)

end

function Snow_OTBarSetting.OnLButtonDown()
	Snow_OTBarFont.OnLButtonHold()
end

function Snow_OTBarSetting.OnLButtonHold()

	local szName = this:GetName()
	if szName == "Btn_Up" then
		this:GetParent():Lookup("Scroll_List"):ScrollPrev(1)
	elseif szName == "Btn_Down" then
		this:GetParent():Lookup("Scroll_List"):ScrollNext(1)
    end

end

function Snow_OTBarSetting.OnItemMouseWheel()

	local nDistance = Station.GetMessageWheelDelta()
	this:GetRoot():Lookup("Scroll_List"):ScrollNext(nDistance)
	return 1

end

function Snow_OTBarSetting.PanelSwitch()

	local frameself = Station.Lookup("Normal/Snow_OTBarSetting")

	if not frameself then
		Wnd.OpenWindow("interface\\Snow_OTBar\\Snow_OTBarPreview.ini","Snow_OTBarPreview")
		Wnd.OpenWindow("interface\\Snow_OTBar\\Snow_OTBarSetting.ini","Snow_OTBarSetting")
	else
		Wnd.CloseWindow("Snow_OTBarSetting")
		Wnd.CloseWindow("Snow_OTBarPreview")
		Wnd.CloseWindow("Snow_OTBarFont")
	end

end

function Snow_OTBarSetting.UpdateSetting(tSetting)

	local frameself = Station.Lookup("Normal/Snow_OTBarSetting")

	if tSetting then
		Snow_OTBarSetting.CurrentSetting = clone(tSetting)
	end

	for k,v in pairs(Snow_OTBarSetting.CurrentSetting) do
		if k == "Frame" then
			if v.nType == 0 then
				frameself:Lookup("CheckBox_bLeftRight"):Check(true)
				frameself:Lookup("CheckBox_bRound"):Check(false)
				frameself:Lookup("CheckBox_bUpDown"):Check(false)
			elseif v.nType == 1 then
				frameself:Lookup("CheckBox_bLeftRight"):Check(false)
				frameself:Lookup("CheckBox_bRound"):Check(true)
				frameself:Lookup("CheckBox_bUpDown"):Check(false)
			elseif v.nType == 2 then
				frameself:Lookup("CheckBox_bLeftRight"):Check(false)
				frameself:Lookup("CheckBox_bRound"):Check(false)
				frameself:Lookup("CheckBox_bUpDown"):Check(true)
			end
		end
		if k == "Background" or k == "Filling" or k == "Icon" or k == "Animate" or k == "TextName" or k == "TextTime" or k == "Lighting" or k == "Divider" then
			frameself:Lookup("Edit_"..k.."_PosX"):SetText(v.nX)
			frameself:Lookup("Edit_"..k.."_PosY"):SetText(v.nY)
			frameself:Lookup("Edit_"..k.."_SizeW"):SetText(v.nW)
			frameself:Lookup("Edit_"..k.."_SizeH"):SetText(v.nH)
			frameself:Lookup("Edit_"..k.."_Alpha"):SetText(v.nAlpha)
			frameself:Lookup("CheckBox_Display_"..k):Check(v.bShow)
			if k == "Icon" then
				if v.nMoveType == 0 then
					frameself:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
				elseif v.nMoveType == 1 then
					frameself:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
				elseif v.Icon.nMoveType == 2 then
					frameself:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
				elseif v.nMoveType == 3 then
					frameself:Lookup("Btn_nIconMove"):Lookup("",""):Lookup(0):SetText("")
				end
			end
			if k == "Animate" then
				if v.nMoveType == 0 then
					frameself:Lookup("Btn_nAnimateMove"):Lookup("",""):Lookup(0):SetText("")
				elseif v.nMoveType == 1 then
					frameself:Lookup("Btn_nAnimateMove"):Lookup("",""):Lookup(0):SetText("")
				elseif v.nMoveType == 2 then
					frameself:Lookup("Btn_nAnimateMove"):Lookup("",""):Lookup(0):SetText("")
				end
			end
		elseif k == "SkinName" then
			frameself:Lookup("Edit_SkinName"):SetText(v)
		elseif k == "AuthorName" then
			frameself:Lookup("Edit_AuthorName"):SetText(v)
		end
	end

	Snow_OTBarSetting.UpdatePreview(tSetting)

end

function Snow_OTBarSetting.UpdatePreview(tSetting)

	if Snow_OTBarSetting.bError then
		return
	end

	if tSetting then
		Snow_OTBarSetting.CurrentSetting = clone(tSetting)
	end

	local szSkinName = ""

	for k,v in pairs(Snow_OTBarSkinList or {}) do
		if v == Snow_OTBarSetting.CurrentSetting.SkinName then
			szSkinName = Snow_OTBarSetting.CurrentSetting.SkinName
		end
	end

	if szSkinName == "" then
		Snow_OTBarSetting.bError = true
		OutputMessage("MSG_SYS","ûҵӦƤļ\n")
		return
	end

	local framepreview = Station.Lookup("Normal/Snow_OTBarPreview")
	local handle = framepreview:Lookup("",""):Lookup("Handle_Preview")
	local szIni = "interface\\Snow_OTBar\\Skins\\"..szSkinName

	for k,v in pairs(Snow_OTBarSetting.CurrentSetting) do

		if k == "Background" or k == "Filling" or k == "Icon" or k == "Animate" or k == "TextName" or k == "TextTime" then
			local item
			if k == "Animate" then
				item = handle:Lookup("Animate_Preview")
				item:SetAnimate(szIni.."\\"..k..".UITex",0)
			elseif k ==  "TextName" or k == "TextTime" then
				item = handle:Lookup("Text_Preview_"..k)
				if k == "TextName" then
					item:SetText("")
				elseif k == "TextTime" then
					item:SetText("--/--")
				end
				item:SetFontScheme(v.nFont)
				item:SetFontScale(v.nScale)
				item:SetFontColor(v.nR,v.nG,v.nB)
			else
				item = handle:Lookup("Image_Preview_"..k)
				if k == "Filling" then
					item:FromTextureFile(szIni.."\\Progress.tga")
					if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
						item:SetImageType(1)
					elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 1 then
						item:SetImageType(13)
					elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
						item:SetImageType(4)
					end
				elseif k == "Icon" then
					item:FromIconID(533)
				else
					item:FromTextureFile(szIni.."\\"..k..".tga")
				end
			end

			if not item then
				return
			end

			if v.bShow then
				item:Show()
				item:SetRelPos(v.nX,v.nY)
				item:SetSize(v.nW,v.nH)
				item:SetAlpha(v.nAlpha)
			else
				item:Hide()
			end
		end
	end

	if Snow_OTBarSetting.CurrentSetting.Lighting.bShow then
		local nPosX,nPosY = handle:Lookup("Image_Preview_Filling"):GetRelPos()
		local nWidth,nHeight = handle:Lookup("Image_Preview_Filling"):GetSize()
		if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 or Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
			handle:Lookup("Animate_Preview_Lighting"):Show()
			handle:Lookup("Animate_Preview_Lighting"):SetAlpha(Snow_OTBarSetting.CurrentSetting.Lighting.nAlpha)
			if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
				handle:Lookup("Animate_Preview_Lighting"):SetRelPos(nWidth + 20 + Snow_OTBarSetting.CurrentSetting.Lighting.nX,nPosY + Snow_OTBarSetting.CurrentSetting.Lighting.nY)
				handle:Lookup("Animate_Preview_Lighting"):SetAnimate(szIni.."\\Lighting.UITex",0)
				handle:Lookup("Animate_Preview_Lighting"):SetSize(Snow_OTBarSetting.CurrentSetting.Lighting.nW,nHeight + Snow_OTBarSetting.CurrentSetting.Lighting.nH)
			else
				handle:Lookup("Animate_Preview_Lighting"):SetRelPos(nPosX,nPosY)
				handle:Lookup("Animate_Preview_Lighting"):SetAnimate(szIni.."\\Lighting.UITex",1)
				handle:Lookup("Animate_Preview_Lighting"):SetSize(nWidth + Snow_OTBarSetting.CurrentSetting.Lighting.nW,Snow_OTBarSetting.CurrentSetting.Lighting.nH)
			end
		else
			handle:Lookup("Animate_Preview_Lighting"):Hide()
		end

	else
		handle:Lookup("Animate_Preview_Lighting"):Hide()
	end

	if Snow_OTBarSetting.CurrentSetting.Divider.bShow and Snow_OTBarSetting.CurrentSetting.Frame.nType ~= 1 then
		local hI = handle:Lookup("Handle_Preview_Divider_List")
		hI:Show()
		hI:Clear()
		for i = 1,2 do
			local divider = hI:AppendItemFromIni("Interface\\Snow_OTBar\\Snow_OTBar.ini", "Handle_Divider","Handle_Divider_"..i)
			divider:SetRelPos(Snow_OTBarSetting.CurrentSetting.Divider.nX + Snow_OTBarSetting.CurrentSetting.Filling.nX + Snow_OTBarSetting.CurrentSetting.Filling.nW / 3 * i,Snow_OTBarSetting.CurrentSetting.Divider.nY + Snow_OTBarSetting.CurrentSetting.Filling.nY)
			divider:Lookup("Image_Divider"):FromTextureFile(Snow_OTBar.Divider)
			divider:Lookup("Image_Divider"):SetSize(Snow_OTBarSetting.CurrentSetting.Divider.nW,Snow_OTBarSetting.CurrentSetting.Divider.nH)
			divider:SetAlpha(Snow_OTBarSetting.CurrentSetting.Divider.nAlpha)
		end
		hI:FormatAllItemPos()
	else
		handle:Lookup("Handle_Preview_Divider_List"):Hide()
	end

	handle:FormatAllItemPos()
end

function Snow_OTBarSetting.UpdateAnimatedPreview(nPercentage,bDefault)

	local framepreview = Station.Lookup("Normal/Snow_OTBarPreview")
	local handle = framepreview:Lookup("",""):Lookup("Handle_Preview")
	handle:Lookup("Image_Preview_Filling"):SetPercentage(nPercentage)

	if Snow_OTBarSetting.nIconW == 0 or nPercentage == 1 then
		if Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 1 then
			Snow_OTBarSetting.nIconW,Snow_OTBarSetting.nIconH = Snow_OTBarSetting.CurrentSetting.Icon.nW * 2,Snow_OTBarSetting.CurrentSetting.Icon.nH * 2
		elseif Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 2 then
			Snow_OTBarSetting.nIconW,Snow_OTBarSetting.nIconH = Snow_OTBarSetting.CurrentSetting.Icon.nW * 0.5,Snow_OTBarSetting.CurrentSetting.Icon.nH * 0.5
		end
	end

	if not bDefault then
		handle:Lookup("Text_Preview_TextTime"):SetText(tostring(math.floor(nPercentage*100)).."/100")
		if Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 1 or Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 2 then
			if Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 1 then
				Snow_OTBarSetting.nIconW = Snow_OTBarSetting.nIconW - 1
				Snow_OTBarSetting.nIconH = Snow_OTBarSetting.nIconH - 1
				if Snow_OTBarSetting.nIconW < Snow_OTBarSetting.CurrentSetting.Icon.nW then
					Snow_OTBarSetting.nIconW = Snow_OTBarSetting.CurrentSetting.Icon.nW
				end

				if Snow_OTBarSetting.nIconH < Snow_OTBarSetting.CurrentSetting.Icon.nH then
					Snow_OTBarSetting.nIconH = Snow_OTBarSetting.CurrentSetting.Icon.nH
				end
			elseif Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 2 then
				Snow_OTBarSetting.nIconW = Snow_OTBarSetting.nIconW + 0.3
				Snow_OTBarSetting.nIconH = Snow_OTBarSetting.nIconH + 0.3

				if Snow_OTBarSetting.nIconW > Snow_OTBarSetting.CurrentSetting.Icon.nW then
					Snow_OTBarSetting.nIconW = Snow_OTBarSetting.CurrentSetting.Icon.nW
				end

				if Snow_OTBarSetting.nIconH > Snow_OTBarSetting.CurrentSetting.Icon.nH then
					Snow_OTBarSetting.nIconH = Snow_OTBarSetting.CurrentSetting.Icon.nH
				end
			end

			local nPosX = Snow_OTBarSetting.CurrentSetting.Icon.nW / 2 - Snow_OTBarSetting.nIconW / 2
			local nPosY = Snow_OTBarSetting.CurrentSetting.Icon.nH / 2 - Snow_OTBarSetting.nIconH / 2

			handle:Lookup("Image_Preview_Icon"):SetSize(Snow_OTBarSetting.nIconW,Snow_OTBarSetting.nIconH)
			handle:Lookup("Image_Preview_Icon"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Icon.nX + nPosX,Snow_OTBarSetting.CurrentSetting.Icon.nY + nPosY)
		elseif Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 3 then
			local nPosX,nPosY = handle:Lookup("Image_Preview_Filling"):GetRelPos()
			local nWidth,nHeight = handle:Lookup("Image_Preview_Filling"):GetSize()
			if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
				local nCurrentPos = nPercentage * nWidth
				handle:Lookup("Image_Preview_Icon"):SetRelPos(nCurrentPos,Snow_OTBarSetting.CurrentSetting.Icon.nY)
			elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
				local nCurrentPos = nPosY + nHeight - (nPercentage * nHeight)
				handle:Lookup("Image_Preview_Icon"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Icon.nX,nCurrentPos)
			end
		end

		if Snow_OTBarSetting.CurrentSetting.Lighting.bShow then
			local nPosX,nPosY = handle:Lookup("Image_Preview_Filling"):GetRelPos()
			local nWidth,nHeight = handle:Lookup("Image_Preview_Filling"):GetSize()
			if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
				local nCurrentPos = (nPercentage * nWidth) + Snow_OTBarSetting.CurrentSetting.Lighting.nX + 20
				handle:Lookup("Animate_Preview_Lighting"):SetSize(Snow_OTBarSetting.CurrentSetting.Lighting.nW,nHeight + Snow_OTBarSetting.CurrentSetting.Lighting.nH)
				handle:Lookup("Animate_Preview_Lighting"):SetRelPos(nCurrentPos + Snow_OTBarSetting.CurrentSetting.Lighting.nX,nPosY + Snow_OTBarSetting.CurrentSetting.Lighting.nY)
			elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
				local nCurrentPos = nPosY + nHeight - (nPercentage * nHeight) + Snow_OTBarSetting.CurrentSetting.Lighting.nY
				handle:Lookup("Animate_Preview_Lighting"):SetSize(nWidth + Snow_OTBarSetting.CurrentSetting.Lighting.nW,Snow_OTBarSetting.CurrentSetting.Lighting.nH)
				handle:Lookup("Animate_Preview_Lighting"):SetRelPos(nPosX + Snow_OTBarSetting.CurrentSetting.Lighting.nX,nCurrentPos + Snow_OTBarSetting.CurrentSetting.Lighting.nY)
			end

		end

		if Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 1 then
			if Snow_OTBarSetting.nAnimateChange == 1 then
				if Snow_OTBarSetting.nAnimateW == 0 then
					Snow_OTBarSetting.nAnimateW = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMax
					Snow_OTBarSetting.nAnimateH = Snow_OTBarSetting.CurrentSetting.Animate.nH * Snow_OTBarSetting.nAnimateMax
				end
				Snow_OTBarSetting.nAnimateW = Snow_OTBarSetting.nAnimateW - 1
				Snow_OTBarSetting.nAnimateH = Snow_OTBarSetting.nAnimateH - 1
			elseif Snow_OTBarSetting.nAnimateChange == 2 then
				if Snow_OTBarSetting.nAnimateW == 0 then
					Snow_OTBarSetting.nAnimateW = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMin
					Snow_OTBarSetting.nAnimateH = Snow_OTBarSetting.CurrentSetting.Animate.nH * Snow_OTBarSetting.nAnimateMin
				end
				Snow_OTBarSetting.nAnimateW = Snow_OTBarSetting.nAnimateW + 1
				Snow_OTBarSetting.nAnimateH = Snow_OTBarSetting.nAnimateH + 1
			end


			if Snow_OTBarSetting.nAnimateW < Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMin and Snow_OTBarSetting.nAnimateChange == 1 then
				Snow_OTBarSetting.nAnimateW = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMin
				Snow_OTBarSetting.nAnimateChange = 2
			elseif Snow_OTBarSetting.nAnimateW > Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMax and Snow_OTBarSetting.nAnimateChange == 2 then
				Snow_OTBarSetting.nAnimateW = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMax
				Snow_OTBarSetting.nAnimateChange = 1
			end

			if Snow_OTBarSetting.nAnimateH < Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMin and Snow_OTBarSetting.nAnimateChange == 1 then
				Snow_OTBarSetting.nAnimateH = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMin
				Snow_OTBarSetting.nAnimateChange = 2
			elseif Snow_OTBarSetting.nAnimateH > Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMax and Snow_OTBarSetting.nAnimateChange == 2 then
				Snow_OTBarSetting.nAnimateH = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBarSetting.nAnimateMax
				Snow_OTBarSetting.nAnimateChange = 1
			end

			local nPosX = Snow_OTBarSetting.CurrentSetting.Animate.nW / 2 - Snow_OTBarSetting.nAnimateW / 2
			local nPosY = Snow_OTBarSetting.CurrentSetting.Animate.nH / 2 - Snow_OTBarSetting.nAnimateH / 2

			handle:Lookup("Animate_Preview"):SetSize(Snow_OTBarSetting.nAnimateW,Snow_OTBarSetting.nAnimateH)
			handle:Lookup("Animate_Preview"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Animate.nX + nPosX,Snow_OTBarSetting.CurrentSetting.Animate.nY + nPosY)

		elseif Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 2 then
			local nPosX,nPosY = handle:Lookup("Image_Preview_Filling"):GetRelPos()
			local nWidth,nHeight = handle:Lookup("Image_Preview_Filling"):GetSize()
			if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
				local nCurrentPos = nPercentage * nWidth
				handle:Lookup("Animate_Preview"):SetRelPos(nCurrentPos,Snow_OTBarSetting.CurrentSetting.Animate.nY)
			elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
				local nCurrentPos = nPosY + nHeight - (nPercentage * nHeight)
				handle:Lookup("Animate_Preview"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Animate.nX,nCurrentPos)
			end
		end
	else
		local nPosX,nPosY = handle:Lookup("Image_Preview_Filling"):GetRelPos()
		local nWidth,nHeight = handle:Lookup("Image_Preview_Filling"):GetSize()
		handle:Lookup("Text_Preview_TextTime"):SetText("--/--")
		handle:Lookup("Image_Preview_Icon"):SetSize(Snow_OTBarSetting.CurrentSetting.Icon.nW,Snow_OTBarSetting.CurrentSetting.Icon.nH)
		handle:Lookup("Image_Preview_Icon"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Icon.nX,Snow_OTBarSetting.CurrentSetting.Icon.nY)
		handle:Lookup("Animate_Preview"):SetSize(Snow_OTBarSetting.CurrentSetting.Animate.nW,Snow_OTBarSetting.CurrentSetting.Animate.nH)
		handle:Lookup("Animate_Preview"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Animate.nX,Snow_OTBarSetting.CurrentSetting.Animate.nY)

		if Snow_OTBarSetting.CurrentSetting.Lighting.bShow then
			if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
				handle:Lookup("Animate_Preview_Lighting"):SetRelPos(nWidth + 20 + Snow_OTBarSetting.CurrentSetting.Lighting.nX,nPosY + Snow_OTBarSetting.CurrentSetting.Lighting.nY)
			elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
				handle:Lookup("Animate_Preview_Lighting"):SetRelPos(nPosX + Snow_OTBarSetting.CurrentSetting.Lighting.nX,nPosY + Snow_OTBarSetting.CurrentSetting.Lighting.nY)
			else
				handle:Lookup("Animate_Preview_Lighting"):Hide()
			end
		end

		Snow_OTBarSetting.nIconW = 0
		Snow_OTBarSetting.nIconH = 0
		Snow_OTBarSetting.nAnimateW = 0
		Snow_OTBarSetting.nAnimateH = 0
	end

	handle:FormatAllItemPos()
end

function Snow_OTBarSetting.OutputSetting(bAll,bDefault)

	local playername = GetClientPlayer().szName:gsub("@.+$","")

	for k,v in pairs(Snow_OTBarSetting.SkinScheme) do

		local szPath = "interface\\Snow_OTBar\\Skins\\"..k.."\\DefaultSetting.txt"

		if not bDefault then
			if IsFileExist(szPath) then
				szPath = "interface\\Snow_OTBar\\Skins\\"..k.."\\"..playername.."-"..k..".txt"
			end
		end

		if bAll then
			SaveLUAData(szPath,v)
		else
			if k == Snow_OTBarSetting.UserData.szCurrentSkin then
				SaveLUAData(szPath,Snow_OTBarSetting.CurrentSetting)
				break
			end
		end
	end

end

function Snow_OTBarSetting.InputSetting(bAll,bDefault)

	local player = GetClientPlayer()

	if not player then
		return
	end

	local playername = player.szName:gsub("@.+$","")

	for i = 1, #Snow_OTBarSkinList do

		local szPath = "interface\\Snow_OTBar\\Skins\\"..Snow_OTBarSkinList[i].."\\"..playername.."-"..Snow_OTBarSkinList[i]..".txt"
		if not bDefault then
			if not IsFileExist(szPath) then
				local szNewPath = szPath
				szPath = "interface\\Snow_OTBar\\Skins\\"..Snow_OTBarSkinList[i].."\\DefaultSetting.txt"
				if IsFileExist(szPath) then
					local temp = LoadLUAData(szPath)
					SaveLUAData(szNewPath,temp)
				else
					local szNewSkinPath = szPath
					szPath = "interface\\Snow_OTBar\\Misc\\NewSkinDefaultSetting.txt"
					local temp = LoadLUAData(szPath)
					temp.SkinName = Snow_OTBarSkinList[i]
					SaveLUAData(szNewSkinPath,temp)
					szPath = szNewSkinPath
				end
			end
		else
			szPath = "interface\\Snow_OTBar\\Skins\\"..Snow_OTBarSkinList[i].."\\DefaultSetting.txt"
			if not IsFileExist(szPath) then
				local szNewSkinPath = szPath
				szPath = "interface\\Snow_OTBar\\Misc\\NewSkinDefaultSetting.txt"
				local temp = LoadLUAData(szPath)
				temp.SkinName = Snow_OTBarSkinList[i]
				SaveLUAData(szNewPath,temp)
				szPath = szNewSkinPath
			end
		end

		if bAll then
			if IsFileExist(szPath) then
				Snow_OTBarSetting.SkinScheme[Snow_OTBarSkinList[i]] = LoadLUAData(szPath)
			end
		else
			if Snow_OTBarSkinList[i] == Snow_OTBarSetting.UserData.szCurrentSkin then
				if IsFileExist(szPath) then
					Snow_OTBarSetting.SkinScheme[Snow_OTBarSetting.UserData.szCurrentSkin] = LoadLUAData(szPath)
					break
				else
					return
				end
			end
		end
	end

end

